/* -*- Javascript -*- */

/* global variables */

var dbhosts = new Array ();
var nbhosts = 0;
var file = null;

/* object */

function Host () {
  return { line: 0, ostname: '', macaddr: '', ipaddr: '' };
}

/* create XML HTML Request object */

function create_xhr_object () {
  if (window.XMLHttpRequest)
    return new XMLHttpRequest ();

  if (window.ActiveXObject) {
    var names = ['Msxml2.XMLHTTP.6.0', 'Msxml2.XMLHTTP.3.0',
                 'Msxml2.XMLHTTP', 'Microsoft.XMLHTTP'];
    for (var i in names) {
      try{
        return new ActiveXObject (names[i]);
      }
      catch (err) {
      }
    }
    window.alert ('your browser does not handle XMLHTTPRequest object.');
  }
  return null;
}

function ajax_post (params, rxfunc) {

  var xhr = create_xhr_object ();

  xhr.onreadystatechange = function() {

    if ((xhr.readyState == 4) && (xhr.status == 200) && (xhr.responseXML != null)) {

      try {
        rxfunc (xhr.responseXML.documentElement.getElementsByTagName ('message')[0]);
      }
      catch (err) {
        update_status ('can\'t understand server answer \'' + err + '\'', -1);
      }

    } else if (xhr.readyState == 4)
      update_status ('network error', -1);
  }

  xhr.open ('POST', 'func.php', true);

  xhr.setRequestHeader ('Content-type', 'application/x-www-form-urlencoded');
  xhr.setRequestHeader ('Content-length', params.length);
  xhr.setRequestHeader ('Connection', 'close');

  xhr.send (params);

}

/* base64 encode function */

var base64_encode = function (a,b,c,d,e,f) {
    b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    c="=";
    for(d=f="";e&=3,a.charAt(d++)||(b="=",e);f+=b.charAt(63&c>>++e*2))c=c<<8|a.charCodeAt(d-=!e);
    return f
};

/* base64 decode function */

var base64_decode = function (d,b,c,u,r,q,x) {
    b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    for(r=q=x="";c=d.charAt(x++);~c&&(u=q%4?u*64+c:c,q++%4)?r+=String.fromCharCode(255&u>>(-2*q&6)):0) c=b.indexOf(c);
    return r;
};

/* status function */

function update_status (message, stat, incr) {

  if (message == null) message = '';
  message = message.replace (/\n*$/, '');

  var classname = 'empty';
  if (message.length > 0) {
    if (stat == -1) classname = 'server';
    else if (stat == 0) classname = 'message';
    else if (stat == 1) classname = 'warning';
    else classname = 'error';
  }

  var status = document.getElementById ('status');

  status.className = classname;

  if (!incr)
    status.innerHTML = '';
  status.innerHTML += '<p>' + message.replace (/\n/g, '</p>\n<p>') + '</p>';

}

/* menu action */

function show_tab (func, arg1) {

  var list_of_pages = new Array('help', 'edit');

  for (var i in list_of_pages) {

    var page = document.getElementById ('page_' + list_of_pages[i]);
    page.style.display = 'none';

  }

  var page = document.getElementById ('page_' + func);
  page.style.display = 'block';

  //var message = menu_callbacks['cb_' + func](arg1);
  var message = '';

  update_status (message, (message.length > 0) ? 1 : 0);
}


/* import procedure */

function import_proc (data) {

  /* remove previous table */
  var table = document.getElementById ('dbhosts');
  if (!table) {
    update_status ('can\'t find previous table');
    return;
  }
  var father = table.parentNode;
  father.removeChild (table);

  /* clean previous list */
  dbhosts = new Array ();
  nbhosts = 0;
  file = data;

  /* create new table */
  table = document.createElement ('table');
  table.className = 'table';
  table.id = 'dbhosts';

  /* create header row */
  var row_db_header = table.insertRow (0);

  /* create hostname column */
  var cell_db_hostname_header = document.createElement('th');
  row_db_header.appendChild (cell_db_hostname_header);
  cell_db_hostname_header.className = 'fit';
  cell_db_hostname_header.innerHTML = 'Hostname';

  /* create mac address column */
  var cell_db_macaddress_header = document.createElement('th');
  cell_db_macaddress_header.className = 'expand';
  row_db_header.appendChild (cell_db_macaddress_header);
  cell_db_macaddress_header.innerHTML = 'MAC address';

  /* create ip address column */
  var cell_db_ipaddress_header = document.createElement('th');
  row_db_header.appendChild (cell_db_ipaddress_header);
  cell_db_ipaddress_header.innerHTML = 'IP address';

  /* add new table into html page */
  father.appendChild (table);

  /* process line by line */
  var tab = data.split ('\n');
  for (var i in tab) {

    /* avoid comments and keep only host line */
    var line = tab[i].replace (/#.*/, ''). replace (/;/g, ' ', 'g');
    if (!line.match (/host/))
      continue;

    /* new entry */
    dbhosts[nbhosts++] = new Host ();
    dbhosts[nbhosts - 1].line = i;

    /* analyse each word */
    var word = line.split (' ');
    var action = '';
    for (var j in word) {

      /* look for keyword */
      switch (word[j]) {
      case '': break;
      case 'host': action = 'host'; break;
      case 'ethernet': action = 'macaddr'; break;
      case 'fixed-address': action = 'ipaddr'; break;
      default:

        /* retrieve fields */
        switch (action) {
        case 'host': dbhosts[nbhosts - 1].hostname = word[j]; action = ''; break;
        case 'macaddr': dbhosts[nbhosts - 1].macaddr =  word[j]; action = ''; break;
        case 'ipaddr': dbhosts[nbhosts - 1].ipaddr =  word[j]; action = ''; break;
        }

        break;
      }
    }
  }

  /* create table */
  for (var i in dbhosts) {

    /* create row */
    var row_db = table.insertRow (table.rows.length);

    /* create hostname column */
    var cell_db_hostname = document.createElement('td');
    row_db.appendChild (cell_db_hostname);
    cell_db_hostname.innerHTML = dbhosts[i].hostname;

    /* create mac address column */
    var cell_db_macaddress = document.createElement('td');
    cell_db_macaddress.className = 'expand';
    row_db.appendChild (cell_db_macaddress);
    var input_db_macaddress = document.createElement ('input');
    input_db_macaddress.type = 'text';
    input_db_macaddress.id = 'macaddr_' + i;
    input_db_macaddress.value = dbhosts[i].macaddr;
    cell_db_macaddress.appendChild (input_db_macaddress);

    /* create ip address column */
    var cell_db_ipaddress = document.createElement('td');
    row_db.appendChild (cell_db_ipaddress);
    cell_db_ipaddress.innerHTML = dbhosts[i].ipaddr;

  }

  /* table is updated */
  update_status ('import done', 0);
}

/* import file */

function import_file () {

  /* get file name */
  var files = document.getElementById ('import_name').files;
  if (!files.length) {
    update_status ('please select a file!', 1);
    return;
  }

  /* read file */
  var file = files[0];
  var reader = new FileReader();
  reader.onload = function(e) { import_proc (e.target.result); };
  reader.onerror = function(e) { update_status ('can\'t read file (' + e.target.error.code + ')', 1); };
  reader.readAsText(file);

  update_status ('file "' + file.name + '" loading', 0);
}

/* export raw database */

function export_proc () {

  for (var i in dbhosts) {
    var ref = document.getElementById ('macaddr_' + i);
    if (ref)
      dbhosts[i].macaddr = ref.value;
  }

  /* process line by line */
  var tab = file.split ('\n');
  var j = 0;
  var data = '';
  for (var i in tab) {
    if ((j < dbhosts.length) && (dbhosts[j].line == i)) {
      tab[i] = 'host ' + dbhosts[j].hostname + ' { hardware ethernet ' + dbhosts[j].macaddr + '; fixed-address ' + dbhosts[j].ipaddr + ';}';
      j++;
    }
    data += tab[i] + '\n';
  }

  return data;
}

/* export file */

function export_file () {

  var data = export_proc ();

  window.location.href = 'data:text/text;charset=UTF-8,' + encodeURIComponent (data);

  update_status ('export DHCPconfiguration successfully completed', 0);

  return '';
}

/* load function */

function load_file () {

  /* update status */
  update_status ('loading DHCPD configuration', 0);

  /* create request message */
  var params = 'action=load';
  var rxfunc = function (message) {
    var stat = message.getElementsByTagName ('stat')[0].firstChild.nodeValue;
    if (stat == 0) {
      var data = message.getElementsByTagName ('data')[0].firstChild.nodeValue;
      import_proc (base64_decode (data));
    } else {

      /* update status on error */
      update_status ('error while loaded DHCPD configuration (' + stat + ')', 2);
    }
  };

  ajax_post (params, rxfunc);

  return '';
}

/* save function */

function save_file () {

  /* update status */
  update_status ('saving DHCPD configuration', 0);

  /* create csv data */
  var data = export_proc ();

  /* create request message */
  var params = 'action=save&data=' + base64_encode (data);
  var rxfunc = function (message) {
    var stat = message.getElementsByTagName ('stat')[0].firstChild.nodeValue;
    if (stat == 0) {
      /* update status on success */
      update_status ('DCHP configuration saved', 0);
    } else {
      /* update status on error */
      update_status ('error while savind DCHP configuration (' + stat + ')', 2);
    }
  };

  ajax_post (params, rxfunc);

  return '';
}
